/*
 * measureDb.h
 *
 *  Created on: May 30, 2012
 *      Author: mschoepf
 */

#ifndef MEASUREDB_H_
#define MEASUREDB_H_

#include "xcfMemoryListener.h"
#include <Qt/qapplication.h>
#include <Qt/qlabel.h>
#include <Qt/qprogressbar.h>
#include <Qt/qlayout.h>
#include <Qt/qpushbutton.h>
#include <Qt/qmainwindow.h>
#include <Qt/qtextedit.h>
#include <Qt/qspinbox.h>
#include <Qt/qmessagebox.h>
#include <xcf/xcf.hpp>
#include <xmltio/Location.hpp>
#include "EqualizerWidget.h"

class measureDbMainWindow : public QMainWindow
{
	Q_OBJECT

private:
	float maxDb;
	float averageDb;
	float stAverageDb;
	QFrame* baseFrame;
	QVBoxLayout* eqVBoxLayout;
	QHBoxLayout* eqHBoxLayout;
	QHBoxLayout* eqHBoxLayout2;
	EqualizerWidget* ew;
	QLabel* dbLabel;
	QLabel* wellLabel;
	QLabel* clippedCountLabel;
	QLabel* isrStartLabel;
	QLabel* isrUttLabel;
	QSpinBox* isrStartSpinBox;
	QSpinBox* isrUttSpinBox;
	QPushButton* sendToIsrButton;
	QTextEdit* isrResultsTextEdit;
	QPushButton* connectToIsrButton;
	QPushButton* disconnectFromIsrButton;
	QPushButton* enableOutputIsrButton;
	QPushButton* disableOutputIsrButton;
	QPushButton* pauseLsearchIsrButton;
	QPushButton* resumeLsearchIsrButton;
	QPushButton* quitButton;
	xcfMemoryListener* xmem;
	void disableConnectButton();
	void enableConnectButton();
	void disableOutputButton();
	void enableOutputButton();
	void enablePauseButton();
	void disablePauseButton();


/*protected:
    virtual void paintEvent(QPaintEvent *event);*/

signals:
	void gotQuit();

public slots:
	void update_eq (float val, int db_start, int db_utt, QString phase);
	void update_text (QString update);
	void quit ();
	void sendToIsr();
	void gotDisconnect();
	void triggerConnectToIsr();
	void triggerDisconnectFromIsr();
	void triggerEnableOutput();
	void triggerDisableOutput();
	void triggerPauseLsearch();
	void triggerResumeLsearch();

public:
	explicit measureDbMainWindow(QWidget *parent = 0);
    ~measureDbMainWindow();
};



#endif /* MEASUREDB_H_ */
