/*
 * xcfMemoryListener.h
 *
 *  Created on: Jun 11, 2012
 *      Author: mschoepf
 */

#ifndef XCFMEMORYLISTENER_H_
#define XCFMEMORYLISTENER_H_

#include <xcf/xcf.hpp>
#include <xmltio/xmltio.hpp>
#include <xmltio/Location.hpp>
#include <xmltio/XPath.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/thread.hpp>
#include <Qt/qobject.h>
#include <iostream>
#include <string>
#include <sstream>

class xcfMemoryListener : public QObject{
	Q_OBJECT
private:
	XCF::SubscriberPtr _subscriber;
	boost::scoped_ptr<boost::thread> readThreadPtr;
	bool connected;
	void runner();
signals:
	void updated_dB (float db, int db_start, int db_utt, QString phase);
	void newIsrHyp (QString isrHyp);
	void disconnected();
public:
	bool connectToIsr();
	void disconnectFromIsr();
	bool isConnected() const;
	xcfMemoryListener();
	virtual ~xcfMemoryListener();
};

#endif /* XCFMEMORYLISTENER_H_ */
